# -*- coding: utf-8 -*-
# Generated by Django 1.11.9 on 2020-12-23 23:43
from __future__ import unicode_literals

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion
import xyz_util.modelutils


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name='Group',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=64, verbose_name='\u540d\u79f0')),
                ('is_active', models.BooleanField(default=True, verbose_name='\u6709\u6548')),
                ('create_time', models.DateTimeField(auto_now_add=True, verbose_name='\u521b\u5efa\u65f6\u95f4')),
                ('update_time', models.DateTimeField(auto_now=True, verbose_name='\u521b\u5efa\u65f6\u95f4')),
                ('creator', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='clockin_groups', to=settings.AUTH_USER_MODEL, verbose_name='user')),
            ],
            options={
                'verbose_name': '\u5c0f\u7ec4',
                'verbose_name_plural': '\u5c0f\u7ec4',
            },
        ),
        migrations.CreateModel(
            name='MemberShip',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('user_name', models.CharField(max_length=64, verbose_name='\u7528\u6237\u59d3\u540d')),
                ('is_active', models.BooleanField(default=True, verbose_name='\u6709\u6548')),
                ('create_time', models.DateTimeField(auto_now_add=True, verbose_name='\u521b\u5efa\u65f6\u95f4')),
                ('update_time', models.DateTimeField(auto_now=True, verbose_name='\u521b\u5efa\u65f6\u95f4')),
                ('group', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='memberships', to='clockin.Group', verbose_name='\u5c0f\u7ec4')),
                ('user', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='clockin_memberships', to=settings.AUTH_USER_MODEL, verbose_name='user')),
            ],
            options={
                'verbose_name': '\u6210\u5458',
                'verbose_name_plural': '\u6210\u5458',
            },
        ),
        migrations.CreateModel(
            name='Point',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('value', models.PositiveIntegerField(blank=True, default=0, null=True, verbose_name='\u79ef\u5206')),
                ('detail', xyz_util.modelutils.JSONField(blank=True, null=True, verbose_name='\u8be6\u60c5')),
                ('create_time', models.DateTimeField(auto_now_add=True, verbose_name='\u521b\u5efa\u65f6\u95f4')),
                ('update_time', models.DateTimeField(auto_now=True, verbose_name='\u521b\u5efa\u65f6\u95f4')),
                ('group', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='points', to='clockin.Group', verbose_name='\u5c0f\u7ec4')),
            ],
            options={
                'verbose_name': '\u6210\u7ee9',
                'verbose_name_plural': '\u6210\u7ee9',
            },
        ),
        migrations.CreateModel(
            name='Session',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(blank=True, default='\u7b2c\u4e00\u671f', max_length=64, verbose_name='\u540d\u79f0')),
                ('number', models.PositiveIntegerField(default=1, verbose_name='\u5e8f\u53f7')),
                ('is_active', models.BooleanField(default=True, verbose_name='\u6709\u6548')),
                ('begin_time', models.DateTimeField(blank=True, verbose_name='\u5f00\u59cb\u65f6\u95f4')),
                ('end_time', models.DateTimeField(blank=True, verbose_name='\u7ed3\u675f\u65f6\u95f4')),
                ('items', xyz_util.modelutils.JSONField(blank=True, null=True, verbose_name='\u9879\u76ee')),
                ('create_time', models.DateTimeField(auto_now_add=True, verbose_name='\u521b\u5efa\u65f6\u95f4')),
                ('update_time', models.DateTimeField(auto_now=True, verbose_name='\u521b\u5efa\u65f6\u95f4')),
                ('group', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='sessions', to='clockin.Group', verbose_name='\u5c0f\u7ec4')),
            ],
            options={
                'verbose_name': '\u5468\u671f',
                'verbose_name_plural': '\u5468\u671f',
            },
        ),
        migrations.AddField(
            model_name='point',
            name='session',
            field=models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='points', to='clockin.Session', verbose_name='\u5468\u671f'),
        ),
        migrations.AddField(
            model_name='point',
            name='user',
            field=models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='clockin_points', to=settings.AUTH_USER_MODEL, verbose_name='user'),
        ),
        migrations.AlterUniqueTogether(
            name='membership',
            unique_together=set([('group', 'user')]),
        ),
        migrations.AlterUniqueTogether(
            name='group',
            unique_together=set([('creator', 'name')]),
        ),
    ]
